
# $Id#

. /etc/default/rcS

if ! [ -d /topspin-recovery ]; then
	exit 0
fi
if ! [ -x /sbin/mke2fs ]; then
	exit 0
fi

# Debug hook to preserve /topspin.
if [ ! -z "$PRESERVE_TOPSPIN" ]; then
    echo "Preserving /topspin."
    insmod /sbin/doc.o
    mount /dev/msys/fla2 /topspin
    exit 0
fi

[ "$VERBOSE" != no ] && echo -n "Recreating /topspin."

insmod /sbin/doc.o

[ "$VERBOSE" != no ] && echo -n "Save log files."
mkdir /topspin-orig
mount -r /dev/msys/fla2 /topspin-orig
cp /topspin-orig/log/ts_log /tmp
cp /topspin-orig/log/hwif_log /tmp
sync
umount /topspin-orig

mke2fs -j /dev/msys/fla2
if [ $? -ne 0 ]; then
    echo -n ": warning: mke2fs failed"    
    # I'm not sure what we can do here!
fi

mkdir -p /topspin
mount /dev/msys/fla2 /topspin
mkdir -p /topspin/etc
mkdir -p /topspin/log
cp /tmp/ts_log /topspin/log/ts_log.old
cp /tmp/hwif_log /topspin/log/hwif_log.old
gzip /topspin/log/ts_log.old
gzip /topspin/log/hwif_log.old

mkdir -p /topspin/images
# Only needed on CC/LT, but easier to do it unconditionally.
mkdir -p /topspin/config/runtime
mkdir -p /topspin/config/system

[ "$VERBOSE" != no ] && echo "."
