
# $Id: S36newkernel.sh,v 1.7 2003/04/02 17:12:04 scott Exp $

. /etc/default/rcS

KERNEL_ROOTFS_IMG=/topspin/images/boot/kernel_rootfs_install.img
if ! [ -f $KERNEL_ROOTFS_IMG ]; then
	exit 0
fi
if ! [ -x /bin/dd ]; then
	exit 0
fi

[ "$VERBOSE" != no ] && echo "Installing new kernel+rootfs."
# Using bs= seems to speed it up a little bit
/bin/dd if=$KERNEL_ROOTFS_IMG of=/dev/msys/fla1 bs=32k
if [ $? -ne 0 ]; then
    echo -n ": warning: dd failed"    
    # TODO: Run recovery image if dd fails?  Or will ppcboot take care of it?
fi
sync
rm $KERNEL_ROOTFS_IMG
sync
[ "$VERBOSE" != no ] && echo "."

# We get IPL and PPCboot from /topspin.
#if [ ! -f /topspin/images/boot/topspin_install.img ]; then
#    exit 0
#fi
#if [ ! -f /bin/tsarch ]; then
#    exit 0
#fi

[ "$VERBOSE" != no ] && echo "Installing new IPL and PPCboot."

BOOT_VERSION=$(readlink /topspin/images/boot)

TS_ARCH=$(/bin/tsarch)

# Unpack needed files, S99topspin will unpack everything.
gunzip < /topspin/images/boot/topspin_install.img | tar -C /topspin/images -xvf -  ./$BOOT_VERSION/exe/$TS_ARCH/dformat ./$BOOT_VERSION/exe/$TS_ARCH/ipl.bin ./$BOOT_VERSION/exe/$TS_ARCH/ppcboot.bin

# Bug 1628: we must umount /topspin and rmmod doc.o to use dformat.
mv /topspin/images/boot/exe/$TS_ARCH/dformat /topspin/images/boot/exe/$TS_ARCH/ipl.bin /topspin/images/boot/exe/$TS_ARCH/ppcboot.bin /tmp
sync
umount /topspin
if [ $? -ne 0 ]; then
    echo Cannot umount /topspin, not installing IPL and ppcboot.
    ps -efl
    sh
else
    rmmod doc
    if [ $? -ne 0 ]; then
     	echo Cannot rmmod doc.o, not installing IPL and ppcboot.
    else 
	/tmp/dformat -win:fff0000 -ipl:/tmp/ipl.bin -bdkf0:/tmp/ppcboot.bin -noformat
	    
    # We are not quite ready for 2nd ppcboot yet. 
    #/tmp/dformat -win:fff0000 -bdkf1:/tmp/ppcboot.bin -noformat
    fi
fi
    
[ "$VERBOSE" != no ] && echo "."

echo " "
echo " "
echo " "
echo " "
echo " "
echo " "
echo Rebooting to get new image loaded.
# VERY IMPORTANT: we have to rm S99topspin, otherwise if it runs after 
# /topspin is unmounted, then we think we need to reboot into recovery 
# image, as reboot is not synchronous.
rm /etc/rcS.d/S99topspin
/sbin/reboot
