
# $Id: S59sshd.sh,v 1.3 2003/02/03 08:30:10 scott Exp $

. /etc/default/rcS

KEYGEN=/bin/ssh-keygen
SSHD=/sbin/sshd
RSA1_KEY=/topspin/etc/ssh_host_key
RSA_KEY=/topspin/etc/ssh_host_rsa_key
DSA_KEY=/topspin/etc/ssh_host_dsa_key

if [ ! -s $RSA1_KEY ]; then
    echo -n "Generating SSH1 RSA host key: "
    if $KEYGEN -q -t rsa1 -f $RSA1_KEY -C '' -N '' > /dev/null 2>&1 ; then
	chmod 600 $RSA1_KEY
	chmod 644 $RSA1_KEY.pub
	echo "done"
    else
	echo "failed"
        exit 1
    fi
fi

if [ ! -s $RSA_KEY ]; then
    echo -n "Generating SSH2 RSA host key: "
    if $KEYGEN -q -t rsa -f $RSA_KEY -C '' -N '' > /dev/null 2>&1 ; then
	chmod 600 $RSA_KEY
	chmod 644 $RSA_KEY.pub
	echo "done"
    else
	echo "failed"
        exit 1
    fi
fi

if [ ! -s $DSA_KEY ]; then
    [ "$VERBOSE" != no ] && echo -n "Generating SSH2 DSA host key: "
    if $KEYGEN -q -t dsa -f $DSA_KEY -C '' -N '' > /dev/null 2>&1 ; then
	chmod 600 $DSA_KEY
	chmod 644 $DSA_KEY.pub
	[ "$VERBOSE" != no ] && echo "done"
    else
	[ "$VERBOSE" != no ] && echo "failed"
        exit 1
    fi
fi

[ "$VERBOSE" != no ] && echo -n "Starting sshd"
chown root:sys /var/empty
$SSHD
[ "$VERBOSE" != no ] && echo "."

: exit 0
