#-*- mode: Fundamental; tab-width: 4; -*-
# ex:ts=4
# $Id: gar.conf.mk,v 1.7 2003/12/02 06:29:57 scott Exp $

# This file contains configuration variables that are global to
# the GAR system.  Users wishing to make a change on a
# per-package basis should edit the category/package/Makefile, or
# specify environment variables on the make command-line.

# Variables that define the default *actions* (rather than just
# default data) of the system will remain in bbc.gar.mk
# (bbc.port.mk)


# These are the standard directory name variables from all GNU
# makefiles.  They're also used by autoconf, and can be adapted
# for a variety of build systems.
# 
# TODO: set $(SYSCONFDIR) and $(LOCALSTATEDIR) to never use
# /usr/etc or /usr/var
prefix = /
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
sbindir = $(exec_prefix)/sbin
libexecdir = $(exec_prefix)/libexec
datadir = $(prefix)/share
sysconfdir = $(prefix)/etc
sharedstatedir = $(prefix)/share
localstatedir = $(prefix)/var
libdir = $(exec_prefix)/lib
infodir = $(BUILD_PREFIX)/info
lispdir = $(prefix)/share/emacs/site-lisp
includedir = $(BUILD_PREFIX)/include
mandir = $(BUILD_PREFIX)/man
docdir = $(BUILD_PREFIX)/share/doc
sourcedir = $(BUILD_PREFIX)/src

# the DESTDIR is used at INSTALL TIME ONLY to determine what the
# filesystem root should be.  The BUILD_PREFIX is the prefix that
# usurps the DESTDIR.  It should be considered relative to
# $(DESTDIR).  Thus, if includedir were set to
# $(BUILD_PREFIX)/include, it would expand out at install time
# (BUT NO SOONER) to /tmp/gar/../../tmp/build.  The /../../ at
# the front should be harmless, as .. for / is just / itself.
DESTDIR ?= /tmp/gar
BUILD_PREFIX ?= $(ROOTFROMDEST)/tmp/build

# allow us to link to libraries we installed
CPPFLAGS += -I$(DESTDIR)$(includedir)
CFLAGS += -I$(DESTDIR)$(includedir) -L$(DESTDIR)$(libdir)
CXXFLAGS += -I$(DESTDIR)$(includedir) -L$(DESTDIR)$(libdir)
LDFLAGS += -L$(DESTDIR)$(libdir)
# allow us to use programs we just built
PATH := $(PATH):$(DESTDIR)$(bindir):$(DESTDIR)$(sbindir):$(DESTDIR)$(BUILD_PREFIX)/bin:$(DESTDIR)$(BUILD_PREFIX)/sbin
# this causes pain for all involved once glibc is built.
LD_LIBRARY_PATH := /lib:$(DESTDIR)$(libdir):$(DESTDIR)$(BUILD_PREFIX)/lib:/lib:/usr/lib
# LD_PRELOAD +=/lib/libc.so.6

# cross-compile
# Setting conditionally does not seem to work, so set to what build system uses.  Scott 12/01/03
ifdef BUILD_GCOV
CROSS_COMPILE := /data/software/linux/cross-devel/crosstool/powerpc-405-linux-gnu/gcc-3.3.2-glibc-2.3.2/bin/powerpc-405-linux-gnu-
else
CROSS_COMPILE := /data/software/linux/cross-devel/install/405/bin/ppc-linux-
endif
CC := $(CROSS_COMPILE)gcc
CXX := $(CROSS_COMPILE)g++
LD := $(CROSS_COMPILE)ld
AR := $(CROSS_COMPILE)ar
STRIP := $(CROSS_COMPILE)strip
RANLIB := $(CROSS_COMPILE)ranlib

# This is for foo-config chaos
PKG_CONFIG_PATH=$(DESTDIR)$(libdir)/pkgconfig/

# make these variables available to configure and build scripts
# outside of make's realm.
export DESTDIR prefix exec_prefix bindir sbindir libexecdir datadir sysconfdir 
export sharedstatedir localstatedir libdir infodir lispdir includedir mandir 
export docdir sourcedir
export CROSS_COMPILE
export CC CXX LD AR STRIP RANLIB
export CPPFLAGS CFLAGS CXXFLAGS LDFLAGS PATH LD_LIBRARY_PATH LD_PRELOAD
export PKG_CONFIG_PATH

GARCHIVEDIR = /var/www/garchive/$(DISTNAME)/

# prepend the local file listing
FILE_SITES = file://$(FILEDIR)/
# FILE_SITES = file://$(FILEDIR)/ file://$(GARCHIVEDIR)

#append the public archive
MASTER_SITES += file:///data/software/linux/cross-devel/src/
