/*
 *
 *	Topspin PPC 405GPr switch card card modifications
 * 	Author: Roland Dreier
 *         	roland@topspin.com
 * 	   	debbie_chu@mvista.com
 *
 *    Description:
 *      Macros, definitions, and data structures specific to the IBM PowerPC
 *      based boards.
 *
 *      This includes:
 *
 *         405GP Topspin PPC 405GP Buzz switch card
 *
 */

#ifdef __KERNEL__
#ifndef __ASM_TS_BUZZ_SC_H__
#define __ASM_TS_BUZZ_SC_H__

/* We have a 405GP core */
#include <platforms/ibm405gp.h>

#ifndef __ASSEMBLY__
/*
  Data structure defining board information maintained by ppcboot
  boot ROM.
*/

#include <asm/ppcboot.h>
/* Some 4xx parts use a different timebase frequency from the internal
   clock. */
#define bi_tbfreq bi_procfreq


/* Memory map for the IBM "Walnut" 405GP evaluation board.
 * Generic 4xx plus RTC.
 */

extern void *walnut_rtc_base;
#define WALNUT_RTC_PADDR	((uint)0xf0000000)
#define WALNUT_RTC_VADDR	WALNUT_RTC_PADDR
#define WALNUT_RTC_SIZE		((uint)8*1024)

/*
  Use external clock at 3.6864 MHz.  Then base baud rate is
  3686400 / 16 = 230400
*/
#define BASE_BAUD               230400

#define WALNUT_FPGA_BASE	0xF0300000

#define PPC4xx_MACHINE_NAME	"Topspin Buzz 1X switch card"

#endif /* !__ASSEMBLY__ */
#endif /* __ASM_TS_BUZZ_SC_H__ */
#endif /* __KERNEL__ */
