/* m4/iic.inc, openbios_ebony, ebony_bios 6/17/99 12:53:46 
!------------------------------------------------------------------------------+
!
!       This source code has been made available to you by IBM on an AS-IS
!       basis.  Anyone receiving this source is licensed under IBM
!       copyrights to use it in any way he or she deems fit, including
!       copying it, modifying it, compiling it, and redistributing it either
!       with or without modifications.  No license under IBM patents or
!       patent applications is to be implied by the copyright license.
!
!       Any user of this software should understand that IBM cannot provide
!       technical support for this software and will not be responsible for
!       any consequences resulting from the use of this software.
!
!       Any person who transfers this source code or any derivative work
!       must include the IBM copyright notice, this paragraph, and the
!       preceding two paragraphs in the transferred software.
!
!       COPYRIGHT   I B M   CORPORATION 1995
!       LICENSED MATERIAL  -  PROGRAM PROPERTY OF I B M
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
!
!  File Name:   iic.inc 
!
!  Function:    Defines for IIC access
!
!  Author:      James Burke   
!
!  Change Activity-
!
!  Date        Description of Change                                       BY
!  ---------   ---------------------                                       ---
!  17-May-99   Created                                                     JWB
!  13-Sep-00   Port to 440GP                                               DWG
!
!-------------------------------------------------------------------------------
*/

#ifndef __IIC_INC__
#define __IIC_INC__

#ifdef __cplusplus
extern "C" {
#endif

#define IIC_MDBUF       0x00
#define IIC_SDBUF       0x02
#define IIC_LMADR       0x04
#define IIC_HMADR       0x05
#define IIC_CNTL        0x06
#define IIC_MDCNTL      0x07
#define IIC_STS         0x08
#define IIC_EXTSTS      0x09
#define IIC_LSADR       0x0A
#define IIC_HSADR       0x0B
#define IIC_CLKDIV      0x0C
#define IIC_INTRMSK     0x0D
#define IIC_XFRCNT      0x0E
#define IIC_XTCNTLSS    0x0F
#define IIC_DIRECTCNTL  0x10

#define IIC0_MDBUF      (IIC0_MMIO_BASE + IIC_MDBUF)
#define IIC0_SDBUF      (IIC0_MMIO_BASE + IIC_SDBUF)
#define IIC0_LMADR      (IIC0_MMIO_BASE + IIC_LMADR)
#define IIC0_HMADR      (IIC0_MMIO_BASE + IIC_HMADR)
#define IIC0_CNTL       (IIC0_MMIO_BASE + IIC_CNTL)
#define IIC0_MDCNTL     (IIC0_MMIO_BASE + IIC_MDCNTL)
#define IIC0_STS        (IIC0_MMIO_BASE + IIC_STS)
#define IIC0_EXTSTS     (IIC0_MMIO_BASE + IIC_EXTSTS)
#define IIC0_LSADR      (IIC0_MMIO_BASE + IIC_LSADR)
#define IIC0_HSADR      (IIC0_MMIO_BASE + IIC_HSADR)
#define IIC0_CLKDIV     (IIC0_MMIO_BASE + IIC_CLKDIV)
#define IIC0_INTRMSK    (IIC0_MMIO_BASE + IIC_INTRMSK)
#define IIC0_XFRCNT     (IIC0_MMIO_BASE + IIC_XFRCNT)
#define IIC0_XTCNTLSS   (IIC0_MMIO_BASE + IIC_XTCNTLSS)
#define IIC0_DIRECTCNTL (IIC0_MMIO_BASE + IIC_DIRECTCNTL)

#define IIC1_MDBUF      (IIC1_MMIO_BASE + IIC_MDBUF)
#define IIC1_SDBUF      (IIC1_MMIO_BASE + IIC_SDBUF)
#define IIC1_LMADR      (IIC1_MMIO_BASE + IIC_LMADR)
#define IIC1_HMADR      (IIC1_MMIO_BASE + IIC_HMADR)
#define IIC1_CNTL       (IIC1_MMIO_BASE + IIC_CNTL)
#define IIC1_MDCNTL     (IIC1_MMIO_BASE + IIC_MDCNTL)
#define IIC1_STS        (IIC1_MMIO_BASE + IIC_STS)
#define IIC1_EXTSTS     (IIC1_MMIO_BASE + IIC_EXTSTS)
#define IIC1_LSADR      (IIC1_MMIO_BASE + IIC_LSADR)
#define IIC1_HSADR      (IIC1_MMIO_BASE + IIC_HSADR)
#define IIC1_CLKDIV     (IIC1_MMIO_BASE + IIC_CLKDIV)
#define IIC1_INTRMSK    (IIC1_MMIO_BASE + IIC_INTRMSK)
#define IIC1_XFRCNT     (IIC1_MMIO_BASE + IIC_XFRCNT)
#define IIC1_XTCNTLSS   (IIC1_MMIO_BASE + IIC_XTCNTLSS)
#define IIC1_DIRECTCNTL (IIC1_MMIO_BASE + IIC_DIRECTCNTL)

/*----------------------------------------------------------------------------+
| IICx Control Register Defines
+----------------------------------------------------------------------------*/
#define IIC_CNTL_HMT         0x80
#define IIC_CNTL_AMD         0x40
#define IIC_CNTL_TCT_MASK    0x30
#define IIC_CNTL_TCT_1       0x00
#define IIC_CNTL_TCT_2       0x10
#define IIC_CNTL_TCT_3       0x20
#define IIC_CNTL_TCT_4       0x30
#define IIC_CNTL_RPST        0x08
#define IIC_CNTL_CHT         0x04
#define IIC_CNTL_RW          0x02
#define IIC_CNTL_PT          0x01

/*----------------------------------------------------------------------------+
| IICx Mode Control Register Defines
+----------------------------------------------------------------------------*/
#define IIC_MDCNTL_FMDB      0x40

/*----------------------------------------------------------------------------+
| IICx Status Register Defines
+----------------------------------------------------------------------------*/
#define IIC_STS_ERR          0x04
#define IIC_STS_PT           0x01

/*----------------------------------------------------------------------------+
| IICx Extended Control and Slave Status Register Defines
+----------------------------------------------------------------------------*/
#define IIC_XTCNTLSS_SRST    0x01

/*----------------------------------------------------------------------------+
| IICx Direct Control Register Defines
+----------------------------------------------------------------------------*/
#define IIC_DIRECTCNTL_SDAC  0x08
#define IIC_DIRECTCNTL_SCC   0x04
#define IIC_DIRECTCNTL_MSDA  0x02
#define IIC_DIRECTCNTL_MSC   0x01

#ifdef __cplusplus
}
#endif

#endif /* __IIC_INC__ */
