/* m4/opb.inc, openbios_ebony, ebony_bios 7/9/00 14:37:47 
!------------------------------------------------------------------------------+
!
!       This source code has been made available to you by IBM on an AS-IS
!       basis.  Anyone receiving this source is licensed under IBM
!       copyrights to use it in any way he or she deems fit, including
!       copying it, modifying it, compiling it, and redistributing it either
!       with or without modifications.  No license under IBM patents or
!       patent applications is to be implied by the copyright license.
!
!       Any user of this software should understand that IBM cannot provide
!       technical support for this software and will not be responsible for
!       any consequences resulting from the use of this software.
!
!       Any person who transfers this source code or any derivative work
!       must include the IBM copyright notice, this paragraph, and the
!       preceding two paragraphs in the transferred software.
!
!       COPYRIGHT   I B M   CORPORATION 1995
!       LICENSED MATERIAL  -  PROGRAM PROPERTY OF I B M
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
!
!  File Name:   opb.inc
!
!  Function:    Defines for Onchip peripheral bus regsiters 
!		used in assembly language.
!
!  Author:      Dan Goehring
!
!  Change Activity-
!
!  Date        Description of Change                                       BY
!  ---------   ---------------------                                       ---
!  30-Aug-01   Created                                                     DWG
!
!-------------------------------------------------------------------------------
*/

#ifndef __OPB_INC__
#define __OPB_INC__

#ifdef __cplusplus
extern "C" {
#endif

#define OPB0_CTRL  (OPB0_DCR_BASE+0x8) 
#define OPB0_STAT  (OPB0_DCR_BASE+0x9)
#define OPB0_BEARL (OPB0_DCR_BASE+0xA)
#define OPB0_BEARH (OPB0_DCR_BASE+0xB)
#define OPB0_REVID (OPB0_DCR_BASE+0xC)

#define OPB_PRI_MASK 0xC0000000
#define OPB_PRI_0    0x00000000
#define OPB_PRI_1    0x40000000
#define OPB_PRI_2    0x80000000
#define OPB_PRI_3    0xC0000000

#ifdef __cplusplus
}
#endif

#endif /* __OPB_INC__ */
